      SUBROUTINE DE84D(F,M,JSTART,HMIN,EPS,P,YX,X,H,BUL,XP,YP,A,E1,E2,  DE840010
     1                 E3,E4,R,R0,R1,R2,R3,YD,IERR)                     DE840020
         INTEGER IERR,JSTART,M                                          DE840030
         DOUBLE PRECISION A,E1,E2,E3,E4,EPS,H,HMIN,P,R,R0,R1,R2,R3,
     1                    X,XP,YD,YP,YX                                 DE840040
         LOGICAL BUL                                                    DE840050
         DIMENSION A(M,M),E1(M,M),E2(M,M),E3(M,M),E4(M,M),R(M),R0(M),   DE840060
     1             R1(M),R2(M),R3(M),YD(M),YP(M),YX(M)                  DE840070
         DOUBLE PRECISION DABS,DSIGN                                    DE840080
         EXTERNAL AME2D,DE00DS,DE04DQ,DE84DJ,UTDE21                     DE840090
         INTEGER I,J                                                    DE840100
         DOUBLE PRECISION C1,EPS0,EPS1,EPSJ                             DE840110
         LOGICAL BULD,BULEX,BULHM                                       DE840120
         DATA EPS0/1.D-5/                                               DE840130
       IERR = 0                                                         DE840140
       EPS1 = EPS/32.D0                                                 DE840150
       EPSJ = EPS                                                       DE840160
       IF (EPS .LT. EPS0) GO TO 10                                      DE840170
          EPSJ = EPS0                                                   DE840180
   10  CONTINUE                                                         DE840190
       BULD = .TRUE.                                                    DE840200
       BULHM = .FALSE.                                                  DE840210
       BULEX = .FALSE.                                                  DE840220
       IF (JSTART) 60, 80, 20                                           DE840230
   20  CONTINUE                                                         DE840240
       IF (JSTART .EQ. 1) GO TO 110                                     DE840250
          IF (JSTART .EQ. 2) GO TO 30                                   DE840260
             GO TO 90                                                   DE840270
   30  CONTINUE                                                         DE840280
       DO 50 J = 1, M                                                   DE840290
          DO 40 I = 1, M                                                DE840300
             E1(I,J) = E2(I,J)                                          DE840310
   40     CONTINUE                                                      DE840320
   50  CONTINUE                                                         DE840330
       GO TO 100                                                        DE840340
   60  CONTINUE                                                         DE840350
       DO 70 I = 1, M                                                   DE840360
          YX(I) = YP(I)                                                 DE840370
   70  CONTINUE                                                         DE840380
       X = XP                                                           DE840390
   80  CONTINUE                                                         DE840400
       CALL DE84DJ(F,X,YX,A,M,EPSJ,R1,R2)                               DE840410
   90  CONTINUE                                                         DE840420
       C1 = H/4.D0                                                      DE840430
       CALL AME2D(A,C1,M,E1,R,E3,E4)                                    DE840440
       IF (BULEX) GO TO 110                                             DE840450
  100  CONTINUE                                                         DE840460
       CALL DE04DQ(M,E1,E2)                                             DE840470
  110  CONTINUE                                                         DE840480
       C1 = H/2.D0                                                      DE840490
       CALL DE00DS(F,M,X,YX,H,A,E2,YD,R1,R2,R3)                         DE840500
       CALL DE00DS(F,M,X,YX,C1,A,E1,R0,R1,R2,R3)                        DE840510
       CALL DE00DS(F,M,X + C1,R0,C1,A,E1,R,R1,R2,R3)                    DE840520
       DO 120 I = 1, M                                                  DE840530
          R1(I) = (R(I) - YD(I))/15.D0                                  DE840540
          C1 = DABS(R1(I))                                              DE840550
          IF (DABS(R(I)) .GE. P) C1 = C1/DABS(R(I))                     DE840560
          IF (C1 .GT. EPS1) BULD = .FALSE.                              DE840570
          IF (C1 .GE. EPS) GO TO 150                                    DE840580
  120     CONTINUE                                                      DE840590
          DO 130 I = 1, M                                               DE840600
             YP(I) = YX(I)                                              DE840610
  130     CONTINUE                                                      DE840620
          XP = X                                                        DE840630
          DO 140 I = 1, M                                               DE840640
             YX(I) = R(I)                                               DE840650
  140     CONTINUE                                                      DE840660
          X = X + H                                                     DE840670
          IF (BULD) H = H*2.D0                                          DE840680
          GO TO 190                                                     DE840690
  150  CONTINUE                                                         DE840700
       IF (BULHM) GO TO 180                                             DE840710
          H = H/2.D0                                                    DE840720
          BUL = .FALSE.                                                 DE840730
          BULEX = .TRUE.                                                DE840740
          DO 170 J = 1, M                                               DE840750
             DO 160 I = 1, M                                            DE840760
                E2(I,J) = E1(I,J)                                       DE840770
  160        CONTINUE                                                   DE840780
  170     CONTINUE                                                      DE840790
          IF (DABS(H) .GT. DABS(HMIN)) GO TO 90                         DE840800
             H = DSIGN(HMIN,H)                                          DE840810
             BULHM = .TRUE.                                             DE840820
             BULEX = .FALSE.                                            DE840830
             GO TO 90                                                   DE840840
  180  CONTINUE                                                         DE840850
       IERR = 65                                                        DE840860
       CALL UTDE21(IERR,84)                                             DE840870
  190  CONTINUE                                                         DE840880
       JSTART = 1                                                       DE840890
       IF (BULD) JSTART = 2                                             DE840900
       RETURN                                                           DE840910
      END                                                               DE840920
